#load relevant libraries
library(xts)
#load daily prices file
anz_daily_prices <- readRDS("AD_ANZ_dailyMeasures.rds")
#save price from next day as the current price
p_closing_now <- as.double(anz_daily_prices$ClsPrice[-(1)])
#save current day price as previous price
p_closing_prev <-as.double(anz_daily_prices$ClsPrice[-length(anz_daily_prices$ClsPrice)])
#compute returns according to formula
areturns_closing <- (p_closing_now - p_closing_prev ) / p_closing_now
#remove first date from the index
newindex <- index(anz_daily_prices)
newindex <- newindex[-(1)]
#create a data frame with the old one, removing first row
dataframe3 <- coredata(anz_daily_prices) 
dataframe3 <- dataframe3[-1,]
#adding new columns
dataframe3 <- cbind(dataframe3,areturns_closing)
#naming columns in dataframe
dataframe3 <- setNames(dataframe3,c("InstrumentID","EventType","TrdVolume","OpnPrice","ClsPrice","HghPrice","LowPrice","AdjPrice_ClsPrice","AReturn_ClsPrice"))
#create xts object
xts_object = xts(dataframe3,order.by = newindex)
#save it as an R object with time index. 
saveRDS(xts_object,file="AD_ANZ_dailyReturns.rds")